/*
 * Kaliko Client Core Components,
 * Core Components for kaliko Calendar-Applications
 * Copyright (C) 2000-2008 tarent GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * tarent GmbH., hereby disclaims all copyright
 * interest in the program 'Kaliko Client Core Components'
 * Signature of Elmar Geese, 4 March 2008
 * Elmar Geese, CEO tarent GmbH.
 */

/**
 * 
 */
package de.tarent.kaliko.components.actions.impl;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.util.Iterator;

import javax.swing.JColorChooser;

import org.evolvis.xana.action.AbstractGUIAction;

import de.tarent.kaliko.components.utils.Messages;
import de.tarent.kaliko.objects.Category;

/**
 * @author Fabian K&ouml;ster (f.koester@tarent.de) tarent GmbH Bonn
 *
 */
public class SetCategoryColorAction extends AbstractGUIAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6221404329790899480L;

	/**
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		Color color = JColorChooser.showDialog(ActionHelper.getController().getMainFrame(), Messages.getString("Category_Color_Selection_Title"), Color.RED);
		
		if(color == null)
			return;
		
		Iterator<Category> categories = ActionHelper.getController().getCategorySelector().getSelectedCategories().iterator();
		
		while(categories.hasNext())
			ActionHelper.getController().getCategorySelector().setColorForCategory(categories.next(), color);
	}

}
